#include "glwidget.h"

GLWidget::GLWidget(QWidget *parent)
    : QGLWidget(parent),
    mouse_x(0),
    mouse_y(0)
{   

    setFocusPolicy(Qt::StrongFocus);   

    /*
    QVector <Clothoid> cs;

    Clothoid c;

    c.SetArcLen(600.0f);
    c.SetStartCurv(-0.01f);
    c.SetEndCurv(-0.01f);
    c.DoSamples();
    cs.push_back(c);


    c.SetArcLen(300.0f);
    c.SetStartCurv(-0.01f);
    c.SetEndCurv(0.02f);
    c.DoSamples();
    cs.push_back(c);

    c.SetArcLen(300.0f);
    c.SetStartCurv(-0.02f);
    c.SetEndCurv(0.03f);
    c.DoSamples();
    cs.push_back(c);

    c.SetArcLen(300.0f);
    c.SetStartCurv(-0.05f);
    c.SetEndCurv(0.06f);
    c.DoSamples();
    cs.push_back(c);


    for (int i=0; i<cs.size(); ++i) {
        ClothoidSpline csp;
        csp.Add(cs[i]);

        csp.SetStartPosition(QVector2D(200, 800));
        csp.SetStartTangent(QVector2D(1, 0));

        fcurve.Add(csp);
    }
    */

    /*

    //this bit of code does some time benchmarking
    PolyLine p;


    for (int i=0; i<250; ++i)
        p.Add(QVector2D(0,i));        

    for (int i=1; i<250; ++i)
        p.Add(QVector2D(i,250));

    p.Smooth(4);


    int pieces = 0;
    float t = 0.0f;
    while (true) {

        pline.Add(QVector2D(t*70.0f+450.0f, sinf(t)*100.0f+700.0f - t*25.0f));

        ++pieces;
        t+=0.1f;

        if (pieces >= 130)
            break;
    }

    //pline.Smooth(8);

    QTime myTimer;
    myTimer.start();
    DoFrenchCurveFit();

    // do something..
    int nMilliseconds = myTimer.elapsed();

    qDebug() << nMilliseconds << "ms passed for " << pline.Size() << "points";
    ClothoidSpline csp;
    csp.FromPolyline(p, false);

    csp.SetStartPosition(QVector2D(200, 300));
    csp.SetStartTangent((p[1]-p[0]).normalized());

    fcurve.Add(csp);
    */



    float cornercurv = 0.07f;
    ClothoidSpline csp;
    Clothoid c;


    c.SetArcLen(300.0f);
    c.SetStartCurv(0.0f);
    c.SetEndCurv(0.01f);
    c.DoSamples();
    csp.Add(c);


    //
    //this code adds the corner piece
    /*
    c.SetArcLen(150.0f);
    c.SetStartCurv(0.0f);
    c.SetEndCurv(0.0f);
    c.DoSamples();
    csp.Add(c);

    c.SetArcLen(1.0f);
    c.SetStartCurv(0.0f);
    c.SetEndCurv(cornercurv);
    c.DoSamples();
    csp.Add(c);

    c.SetArcLen(20.0f);
    c.SetStartCurv(cornercurv);
    c.SetEndCurv(cornercurv);
    c.DoSamples();
    csp.Add(c);

    c.SetArcLen(1.0f);
    c.SetStartCurv(cornercurv);
    c.SetEndCurv(0.0f);
    c.DoSamples();
    csp.Add(c);

    c.SetArcLen(150.0f);
    c.SetStartCurv(0.0f);
    c.SetEndCurv(0.0f);
    c.DoSamples();
    csp.Add(c);
    */
    //

    csp.SetStartPosition(QVector2D(300, 400));
    csp.SetStartTangent(QVector2D(0,1));

    fcurve.Add(csp);

    csp.Clear();

    /*
      //little circle
    c.SetArcLen(100.0f);
    c.SetStartCurv(0.03f);
    c.SetEndCurv(0.03f);
    c.DoSamples();
    csp.Add(c);
    csp.SetStartPosition(QVector2D(250, 400));
    csp.SetStartTangent(QVector2D(0,1));
    fcurve.Add(csp);
    */


    /*
    QVector <QVector <PolyLine> > lines;
    PolyLine::LoadContours(QString("frenchcurve2.obj.contour"), lines);

    for (int i=0; i<lines.size(); ++i) {
        for (int j=0; j<lines[i].size(); ++j) {

            lines[i][j].Scale(1.5f);
            lines[i][j].Smooth(20);

            ClothoidSpline csp;
            csp.FromPolyline(lines[i][j], false);

            csp.SetStartPosition(lines[i][j][0] + QVector2D(200, 500));
            csp.SetStartTangent((lines[i][j][1]-lines[i][j][0]).normalized());
            //csp.SetStartPosition(QVector2D(0, 0));
            //csp.SetStartTangent(QVector2D(1, 0));

            fcurve.Add(csp);

        }

    }
    */

}

GLWidget::~GLWidget()
{

}

QSize GLWidget::minimumSizeHint() const
{
    return QSize(600, 400);
}

QSize GLWidget::sizeHint() const
{    
    return QSize(6000, 4000);
}

void GLWidget::initializeGL()
{

    glEnable(GL_NORMALIZE);
    //glEnable(GL_DEPTH_TEST);
    glDisable(GL_DEPTH_TEST);

    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);

    glShadeModel(GL_SMOOTH);   

    glClearColor(1, 1, 1, 1);

}

void GLWidget::paintGL()
{   

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    gluOrtho2D(0, winWidth, 0, winHeight);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();   

    //cspline.DrawGL();
    cspline.DrawColours(QVector3D(0.25,0.25,1), QVector3D(0.25,0.25,1));
    //cspline.DrawTanSpaceGL(920, 10, 400, 100, cspline.Length());
    cspline.DrawCurvSpaceGL(510, 10, 400, 100, cspline.Length());

    glLineWidth(4.0f);    
    if (m_bdrawfrench)
        fcurve.DrawGL();
    glLineWidth(2.0f);

    fcurve.DrawCurvGL();
    //ocspline.DrawTanSpaceGL(920, 120, 400, 100, ocspline.Length());
    fcurve.DrawOutCurvGL(510, 120, 400, 100, cspline.Length());

    if (m_bdrawpoly) {
        glColor3f(0, 0, 0);
        pline.DrawGL();
    }

    glLineWidth(1.0f);

    GLenum err = glGetError();
    if (err != GL_NO_ERROR) {
        qDebug() << "GLerror " << err;
    }

}

void GLWidget::resizeGL(int width, int height)
{

    glViewport(0, 0, width, height);    

    winWidth=width;
    winHeight=height;

    updateGL();

}

void GLWidget::mousePressEvent(QMouseEvent * e)
{       

    int x = e->pos().x();
    int y = e->pos().y();

    mouse_x=x;
    mouse_y=y;

    if (e->buttons() & Qt::LeftButton || e->buttons() & Qt::RightButton)
        pline.Clear();

    updateGL();

}

void GLWidget::mouseReleaseEvent(QMouseEvent * e)
{

    if (pline.Size() > 1) {

        qDebug() << "size before " << pline.Size();

        if (e->button() == Qt::RightButton) {

            pline.Smooth(10);

            ClothoidSpline c;
            c.FromPolyline(pline, false);

            c.SetStartPosition(QVector2D(200, 500));
            c.SetStartTangent(pline.StartTangent());

            fcurve.Add(c);

        }
        else if (e->button() == Qt::LeftButton) {

            pline.Smooth(10);

            DoFrenchCurveFit();

        }

        qDebug() << "size after " << pline.Size();

    }

    updateGL();

}

void GLWidget::mouseMoveEvent(QMouseEvent * e)
{

    int x = e->pos().x();
    int y = e->pos().y();

    mouse_x=x;
    mouse_y=y;

    if (e->buttons() & Qt::LeftButton || e->buttons() & Qt::RightButton)
    {
        QVector2D p(e->pos().x(), winHeight - e->pos().y());
        pline.Add(p);
    }

    updateGL();

}

void GLWidget::keyReleaseEvent(QKeyEvent * e)
{

    switch (e->key()) {

    case Qt::Key_Backspace:
        cspline.Remove();
        break;

    default:
        cspline.Add();
        break;

    }

    updateGL();

}

void GLWidget::ChangedECost(int ecost)
{

    fcurve.SetECost(float(ecost) / 100.0f);
    DoFrenchCurveFit();
    updateGL();
}

void GLWidget::ChangedBlendWin(int blendwin)
{
    fcurve.SetBlendPieces(true, blendwin);
    fcurve.DoBlendPieces();
    //DoFrenchCurveFit();
    updateGL();
}

void GLWidget::ChangedPointError(int pointerr)
{
    fcurve.SetPointSpaceError(pointerr);
    DoFrenchCurveFit();
    updateGL();
}

void GLWidget::SetDrawPolyLine(bool b)
{
    m_bdrawpoly = b;
    updateGL();
}

void GLWidget::SetDrawFrenchCurves(bool b)
{
    m_bdrawfrench = b;
    updateGL();
}

void GLWidget::SetDoGreedy(bool b)
{
    m_dogreedy = b;
    DoFrenchCurveFit();
    updateGL();
}


void GLWidget::DoFrenchCurveFit() {

    if (pline.Size() < 2)
        return;

    //cspline.FromPolyline(pline);
    //cspline.SetStartPosition(pline.StartPosition());
    //cspline.SetStartTangent(pline.StartTangent());

    if (!fcurve.Empty()) {

        if (!m_dogreedy)
            fcurve.Fit(pline, cspline, ocspline);
        else
            fcurve.Fit_Greedy(pline, cspline, ocspline);

        cspline.SetStartPosition(pline[0]);
        cspline.SetStartTangent(pline.StartTangent());

        //ocspline.SetStartPosition(pline.StartPosition());
        //ocspline.SetStartTangent(pline.StartTangent());
    }

    updateGL();

}
