#ifndef POLYLINE_H
#define POLYLINE_H

#include <QtGui>
#include <QtOpenGL>

#include <cmath>

class PolyLine
{

public:    

    PolyLine();

    void Add(const QVector2D & p);
    void Clear();
    int Size() const;
    const QVector2D & operator[](const int ind) const;
    QVector2D & operator[](const int ind);

    void DrawGL() const;

    void Scale(const float s);
    void Smooth(const int sWin);

    QVector2D StartTangent() const;
    QVector2D Tangent(const int ind) const;

    void ArcLengths(QVector <float> & arclen) const;    
    void Curvatures(QVector <float> & curv) const;

    static void LoadContours(const QString & path, QVector <QVector <PolyLine> > & contours);

private:

    static float PointCurvature(const QVector2D p1, const QVector2D p2, const QVector2D p3);

    QVector <QVector2D> m_line;

};

#endif // POLYLINE_H
